-- Generated by Ora2Pg, the Oracle database Schema converter, version 20.0
-- Copyright 2000-2019 Gilles DAROLD. All rights reserved.
-- DATASOURCE: dbi:Oracle:host=192.168.1.11;sid=xe;port=31521

SET client_encoding TO 'UTF8';

SET search_path = hr;
\set ON_ERROR_STOP ON

DROP TRIGGER IF EXISTS secure_employees ON employees CASCADE;
drop FUNCTION IF EXISTS hr.secure_dml ();

CREATE OR REPLACE FUNCTION hr.secure_dml () RETURNS TRIGGER AS $body$
BEGIN
  IF TO_CHAR(clock_timestamp(), 'HH24:MI') NOT BETWEEN '08:00' AND '18:00'
        OR TO_CHAR(clock_timestamp(), 'DY') IN ('SAT', 'SUN') THEN
	RAISE EXCEPTION '%', 'You may only make changes during normal office hours' USING ERRCODE = '45205';
	RETURN NULL;
  END IF;
RETURN NEW;  
END;
$body$
LANGUAGE PLPGSQL
SECURITY DEFINER
;
ALTER FUNCTION secure_dml () OWNER TO hr;


CREATE TRIGGER secure_employees
	BEFORE INSERT OR DELETE OR UPDATE  ON employees FOR EACH ROW
	EXECUTE PROCEDURE secure_dml();

